/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.3a Evaluation    (Freeware)
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Date    : 24.12.2009
  
Chip type               : ATtiny26L
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 32
Project :    
(   "" )
*****************************************************/

#include <tiny26.h>
#include <delay.h>

#define ADC_VREF_TYPE   0x00
      #define fi_mode PORTA.1         //      
      #define zero_mode PORTA.2   //         
     #define in_parity PINA.4              //   
     #define out1  PORTB.3              //   -  1
     #define out2  PORTB.6              //   -  2
   
 // Declare your global variables here

unsigned int  temp_voltage;
unsigned char   parity_sign; 
            
 flash    char  data_array [10] [20]={
     {0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0},  // ,  10%  
     {0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0},  // --//--  20%
     {0,1,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,1,0},  // --//--  30%
     {1,0,0,1,0,0,1,0,0,1,1,0,0,1,0,0,1,0,0,1},  // --//--  40%
     {1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1},  // --//--  50%
     {1,1,0,0,1,1,0,0,1,1,1,1,0,0,1,1,0,0,1,1},  // --//--  60%
     {1,1,1,1,0,0,1,1,1,0,0,1,1,1,1,0,0,1,1,1},  // --//--  70%
     {1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1},  // --//--  80%
     {1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},  // --//--  90%
     {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},  // --//--  100%
     };
	 
    // Timer 0 overflow interrupt service routine
    interrupt [TIM0_OVF] void timer0_ovf_isr(void)
      {
        TCCR0=0x00;                    //    0
        TCNT0=0xD8;                    //   0
                  
		  parity_sign= in_parity;      //  -      PA4,
                                                    //           
													//        "parity_sign"
      }
  
     // Read the AD conversion result
   unsigned int read_adc(unsigned char adc_input)
  {
   ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
   // Start the AD conversion
   ADCSR|=0x40;
   // Wait for the AD conversion to complete
   while ((ADCSR & 0x10)==0);
   ADCSR|=0x10;
   return ADCW;
   }

  void main(void)
 {
   // Declare your local variables here

       unsigned char  i,  j,  n, num_pulses;
         i = j =n= out1=out2=parity_sign= 0;

    // Port A initialization
     // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=In 
     // State7=T State6=T State5=T State4=T State3=T State2=1 State1=1 State0=T 
     PORTA=0x06;
     DDRA=0x06;

   // Port B initialization
   // Func7=In Func6=Out Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
   // State7=T State6=0 State5=T State4=T State3=0 State2=T State1=T State0=T 
   PORTB=0x00;
   DDRB=0x48;

   // Timer/Counter 0 initialization
   // Clock source: System Clock
   // Clock value: 7,813 kHz
   TCCR0=0x00;                                   //  
   TCNT0=0xD8;                                  //      5 
  
   // Timer(s)/Counter(s) Interrupt(s) initialization
   TIMSK=0x02;

   // Analog Comparator initialization
   // Analog Comparator: On
   ACSR=0x00;

   // ADC initialization
   // ADC Clock frequency: 1000,000 kHz
   // ADC Voltage Reference: AVCC pin
   ADCSR=0xE0;
   ADMUX=0;   

   //   

        while (ACSR.5);             //    ( )
                                                //  (AIN0>AIN1   )
        delay_ms (5);                  //      
                    
        parity_sign= in_parity;     //  -     
												//   -      
          
        while (ACSR.5);             //    ( )
            
    #asm("sei")                             //   

    //   
     while (1)
     {
          temp_voltage= read_adc(0);       //     
                  
              if (temp_voltage>20)              //        
              
         {                            
                   i= temp_voltage/100;            /*        
                                                              .      
                                                             - 10   20  ( 1020) */
                               n=20;                      ////      

                                while (n)        //      
                                                    
               {
                          TCNT0=0xD8;              //  
                          TCCR0=0x05;                

                               n--;                   //  

                   if (data_array [i] [j] ) {          //    ,     , 
					                                             //         - 
                        
                                           
                            while (!ACSR.5);   /*       
				                                                  ,         
							                                      (AIN0<AIN1     */
                        zero_mode=0;                  //            
                        num_pulses=0;                //       
                      
				       if ( parity_sign)   {         //        (  parity_sign )
                                                         
                           while (ACSR.5 && num_pulses<=15 ) {      //     (AIN0>AIN1   )
						   						                                             //                   

                                     out1=1;          //        
                                     delay_us (23);   //     
                                     out1=0;             //         
									 
								 delay_us (10);                     //       -                    
						    
						       if (!ACSR.5) {                        //  -      (AIN0<AIN1) -    
                                break;                                 //      110   
                                };    
                                 delay_us (110);                  //   
                               
                                num_pulses++;                  //       
                            }
                               while (ACSR.5);                //   ,       
                        }        
                        
						else  {                                       //         (  parity_sign )
                            
						        while (ACSR.5 && num_pulses<=15 )   {        //     (AIN0>AIN1   )
						   						                                             //                   
                                 
								   out2=1;                 //        
                                   delay_us (23);      //     
                                   out2=0;                 //        
	                              
								 delay_us (10);                     //       -                    
												
							    if (!ACSR.5) {                        //  -      (AIN0<AIN1) -    
                                break;                                 //      110   
                                };    
                               
						           delay_us (110);                  //   
                               
                                num_pulses++;                  //       
                            }
                               while (ACSR.5);                //   ,       
                        };
                            zero_mode=1;             //            
                    }

                   else  {    // //        - , :

                                out1=out2=0;                   //     
                                
                                while (!ACSR.5) ;           // ,     
                                                                   
                                while (ACSR.5) ;            // ,   ;
                   };

                             j++;                           //     

                 };         //     20  

                      i = j = out1=out2=0;                  //        

                     
         }
          //********************************************************************************************************************

             //             
              
         else {
                        out1=out2=0;
                       
                         TCCR0=0x05;              //  
						 
                        while (!ACSR.5);           // ,    
                       
                        while (ACSR.5);          // ,   
              };
          };
  }         
    


