/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.3a Evaluation    (Freeware)
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Date    : 24.12.2009
  
Chip type               : ATtiny26L
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 32
Project :    
( )
*****************************************************/
#include <tiny26.h>
#include <delay.h>

      #define ADC_VREF_TYPE 0x00
      #define fi_mode PORTA.1         //      
      #define zero_mode PORTA.2   //         
      #define in_parity PINA.4              //   
      #define out1  PORTB.3              //   -  1
      #define out2  PORTB.6              //   -  2
   
   // Declare your global variables here

  // Read the AD conversion result
  unsigned int read_adc(unsigned char adc_input)
    {
      ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
      // Delay needed for the stabilization of the ADC input voltage
      // Start the AD conversion
         ADCSR|=0x40;
     // Wait for the AD conversion to complete
        while ((ADCSR & 0x10)==0);
        ADCSR|=0x10;
       return ADCW;
   }

  unsigned char   parity_sign; 

  void  delay_f(int time_delay);        //    
  
   // Timer 0 overflow interrupt service routine
   interrupt [TIM0_OVF] void timer0_ovf_isr(void)
    {
        TCCR0=0x00;                    //  
        TCNT0=0xD0;                      // Reinitialize Timer 0 value

         parity_sign=in_parity;         //  -      PA4,
                                                    //           
													//        "parity_sign"
    }

   #pragma warn- // this will prevent warnings
                  //  .      
                          
				    void  delay_f(int time_delay) {

                                   #asm
                                           push R24
                                           push R25
                                           push R30
                                           push R31

                                            ldd  r25,y+1
                                            ld   r24,y

                             waitms_1:
                                            ldi R30,18        
                                            ldi R31,0
                             waitms_2:

                                         sbiw R30,1
                                         brne waitms_2
                                         sbiw r24,1
                                         brne waitms_1       

                                           pop R31
                                           pop R30
                                           pop R25
                                           pop R24
                                                                                
                                           #endasm
                            }
                    #pragma warn+ // enable warnings

  void main(void)
  {   
     int time_delay;
     unsigned char num_pulses;

   // Input/Output Ports initialization
   // Port A initialization

     // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=In 
     // State7=T State6=T State5=T State4=T State3=T State2=1 State1=1 State0=T 
     PORTA=0x06;
     DDRA=0x06;

    // Port B initialization
    // Func7=In Func6=Out Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
    // State7=T State6=0 State5=T State4=T State3=0 State2=T State1=T State0=T 
    PORTB=0x00;
    DDRB=0x48;

    // Timer/Counter 0 initialization
   // Clock source: System Clock
   // Clock value: 7,813 kHz
   TCCR0=0x00;                                   //  
   TCNT0=0xD8;                                  //      5 


    // Timer(s)/Counter(s) Interrupt(s) initialization
    TIMSK=0x02;

    // Analog Comparator initialization
    // Analog Comparator: On
    ACSR=0x00;

    // ADC initialization
    // ADC Clock frequency: 1000,000 kHz
    // ADC Voltage Reference: AVCC pin
    ADMUX=ADC_VREF_TYPE & 0xff;
    ADCSR=0x83;

      //   
           
       while (ACSR.5)   { };          //    ( )
     
       delay_ms (5);                    //      
                    
       parity_sign= in_parity;
          
       while (ACSR.5)   {  };        //    
        
       
       #asm("sei")                      //   

      while (1)
         {
               out1=out2=0;                        //       

              time_delay=read_adc(0);        //    

              if (time_delay>20)                  //        

               {time_delay =time_delay - 1023;       //    (     -    )
                time_delay =- time_delay;               //   -       
                time_delay = time_delay + 2;           //       

                while (!ACSR.5);   /*       
				                                                  ,         
							                                      (AIN0<AIN1     */
                    
                    TCCR0=0x05;               //  

                     if ( parity_sign)   {        //         

                         delay_f(time_delay);  //      
                           
                         fi_mode=0;            //        
                         num_pulses=0;
                             
                           while (ACSR.5 && num_pulses<=15 ) {        //     (AIN0>AIN1   )
						   						                                             //               (15)

                           out1=1;              //        
                           delay_us (23);    //     
                           out1=0;                //         

                             delay_us (10);                     //       -                    
						    
						            if (!ACSR.5) {                        //  -      (AIN0<AIN1) -    
                                    break;                                 //      110   
                                };    
                                 delay_us (110);                  //   
                               
                                num_pulses++;                  //       
                            }
                               while (ACSR.5);                //   ,       
                                
                                 }

                     else  {                               //   

                           delay_f(time_delay);      //       

                              fi_mode=0;            //        
                               
                               num_pulses=0;
                               
                              while (ACSR.5 && num_pulses<=15 ) {        //     (AIN0>AIN1   )
						   						                                             //               (15)

                                  out2=1;              //        
                                 delay_us (23);    //     
                                 out2=0;                //         
                                        
										delay_us (10);                     //       -                    
									 
					 				   if (!ACSR.5) {                        //  -      (AIN0<AIN1) -    
                                       break;                                 //      110   
                                };    
                                 delay_us (110);                  //   
                               
                                num_pulses++;                  //       
                            }
                               while (ACSR.5);                //   ,       
                        }        
                                fi_mode=1;          //        
                }
               
                else {

                          TCCR0=0x05;              //  
						 
                        while (!ACSR.5);           // ,    
                       
                        while (ACSR.5);          // ,   
               };  
		   };
  };


     

